unit VKDBFLockTestCase;

interface

uses  TestFrameWork, Windows, VKDBFDataSet, Sysutils,
      Classes, DB, VKDBFCrypt;

type

  TVKDBFLockTestCase = class(TTestCase)
  private
    dbf1: TVKDBFNTX;
    dbf2: TVKDBFNTX;
  protected
    procedure SetUp; override;
    procedure TearDown; override;
  published
    procedure TestFirst;
  end;

implementation

{ TVKDBFFaultyTestCase }

procedure TVKDBFLockTestCase.TestFirst;
//var
//  i: Integer;
begin

  dbf1.RLock;
  try
    Assert(dbf2.IsRLock);
  finally
    dbf1.UnLock;
    Assert(not dbf2.IsRLock);
  end;

end;

procedure TVKDBFLockTestCase.SetUp;
var
  fh: Integer;
  l: Integer;
  c: array[0..1000] of char;
  q: String;
begin
  inherited SetUp;
  CopyFile( 'faulty\faulty.dbf',
            'tmp\faulty.dbf', False);
  CopyFile( 'faulty\faulty.dbt',
            'tmp\faulty.dbt', False);
  dbf1 := TVKDBFNTX.Create(nil);
  dbf1.DBFFileName := 'tmp\faulty.dbf';
  dbf2 := TVKDBFNTX.Create(nil);
  dbf2.DBFFileName := 'tmp\faulty.dbf';
  fh := FileOpen( 'faulty\password.txt',
                  fmOpenRead or fmShareDenyNone);
  l := FileSeek(fh, 0, 2);
  FileSeek(fh, 0, 0);
  FillChar(c, 1001, #0);
  FileRead(fh, c, l - 2);
  FileClose(fh);
  SetString(q, pChar(@c[0]), l - 2);
  dbf1.Crypt.Password := q;
  dbf1.Crypt.CryptMethod := cmGost;
  dbf1.Crypt.Active := True;
  dbf1.AccessMode.AccessMode := 66;
  dbf1.Active := True;
  dbf2.Crypt.Password := q;
  dbf2.Crypt.CryptMethod := cmGost;
  dbf2.Crypt.Active := True;
  dbf2.AccessMode.AccessMode := 66;
  dbf2.Active := True;
end;

procedure TVKDBFLockTestCase.TearDown;
begin
  try
    if dbf2 <> nil then begin
      try
        if dbf2.Active then dbf2.Close;
      finally
        FreeAndNil(dbf2);
      end;
    end;
    if dbf1 <> nil then begin
      try
        if dbf1.Active then dbf1.Close;
      finally
        FreeAndNil(dbf1);
      end;
    end;
  finally
    DeleteFile('tmp\faulty.dbf');
    DeleteFile('tmp\faulty.dbt');
  end;
  inherited TearDown;
end;

initialization

  TestFramework.RegisterTest(TVKDBFLockTestCase.Suite);

end.
